unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ImgList, ComCtrls, ToolWin, StdCtrls, ExtCtrls;

type
  TFormMain = class(TForm)
    Status: TStatusBar;
    ToolBar: TToolBar;
    tbDisp: TToolButton;
    ImageList: TImageList;
    MainMenu: TMainMenu;
    ActionList: TActionList;
    Open: TOpenDialog;
    Save: TSaveDialog;
    mFile: TMenuItem;
    mHelp: TMenuItem;
    ControlBox: TGroupBox;
    ObjectBox: TGroupBox;
    acNew: TAction;
    acOpen: TAction;
    acSave: TAction;
    tbNew: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    mNew: TMenuItem;
    mOpen: TMenuItem;
    mSave: TMenuItem;
    mSep: TMenuItem;
    mExit: TMenuItem;
    mHelpAbout: TMenuItem;
    acBegin: TAction;
    tbSpace: TToolButton;
    tbBegin: TToolButton;
    Image: TImage;
    acEnd: TAction;
    tbEnd: TToolButton;
    acInput: TAction;
    tbInput: TToolButton;
    acAction: TAction;
    acIf: TAction;
    tbAction: TToolButton;
    tbIf: TToolButton;
    eText: TEdit;
    lText: TLabel;
    acCircle: TAction;
    tbCircle: TToolButton;
    mBlocks: TMenuItem;
    mBegin: TMenuItem;
    mEnd: TMenuItem;
    mInput: TMenuItem;
    mAction: TMenuItem;
    mIf: TMenuItem;
    mCircle: TMenuItem;
    acDel: TAction;
    mSepBlock: TMenuItem;
    mDel: TMenuItem;
    acVLink: TAction;
    tbLink: TToolButton;
    acHLink: TAction;
    tbHLink: TToolButton;
    mHLink: TMenuItem;
    mVLink: TMenuItem;
    acVersion: TAction;
    tbSep: TToolButton;
    tbVersion: TToolButton;
    procedure FormActivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acNewExecute(Sender: TObject);
    procedure acOpenExecute(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure mExitClick(Sender: TObject);
    procedure mHelpAboutClick(Sender: TObject);
    procedure acBeginExecute(Sender: TObject);
    procedure acEndExecute(Sender: TObject);
    procedure acInputExecute(Sender: TObject);
    procedure acActionExecute(Sender: TObject);
    procedure acIfExecute(Sender: TObject);
    procedure acCircleExecute(Sender: TObject);
    procedure acDelExecute(Sender: TObject);
    procedure acVLinkExecute(Sender: TObject);
    procedure acHLinkExecute(Sender: TObject);
    procedure acVersionExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses UAbout, UFlowChart;

{$R *.dfm}

////////////////////////////////////////////////////////////////
//                                            //
////////////////////////////////////////////////////////////////

procedure TFormMain.FormActivate(Sender: TObject);  //  
begin
     Open.InitialDir:=ExtractFileDir(Application.ExeName);
     Save.InitialDir:=Open.InitialDir;
     FlowChart.Image:=Image;
     FlowChart.Edit:=eText;
     Image.Controlstyle:=Image.Controlstyle+[csopaque];
     Image.Parent.Doublebuffered:=true;
end;

procedure TFormMain.FormPaint(Sender: TObject);  //  
begin
     FlowChart.Show;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin    //     
     FlowChart.Image:=nil;
     FlowChart.Edit:=nil;
end;


////////////////////////////////////////////////////////////////
//                                            //
////////////////////////////////////////////////////////////////

procedure TFormMain.acNewExecute(Sender: TObject);  // 
begin
     Status.Panels.Items[0].Text:='';
     FlowChart.Clear;
end;

procedure TFormMain.acOpenExecute(Sender: TObject);  // 
begin
     if not Open.Execute then Exit;
     Status.Panels.Items[0].Text:=Open.FileName;
     Image.Picture.LoadFromFile(Open.FileName);
end;

procedure TFormMain.acSaveExecute(Sender: TObject);  // 
begin
     if not Save.Execute then Exit;
     Status.Panels.Items[0].Text:=Save.FileName;
     Image.Picture.SaveToFile(Save.FileName);
end;

procedure TFormMain.mExitClick(Sender: TObject);  // 
begin
     Close;
end;

procedure TFormMain.mHelpAboutClick(Sender: TObject);  //  
begin
     FormAbout.Left:=(FormMain.Width-FormAbout.Width) div 2;
     FormAbout.Top:=(FormMain.Height-FormAbout.Height) div 2;
     FormAbout.ShowModal;
end;

procedure TFormMain.acBeginExecute(Sender: TObject);  //  ""
begin
     FlowChart.Add(TBlockBegin.Create(Image));
end;

procedure TFormMain.acEndExecute(Sender: TObject);  //  ""
begin
     FlowChart.Add(TBlockEnd.Create(Image));
end;

procedure TFormMain.acInputExecute(Sender: TObject);  //  "-"
begin
     FlowChart.Add(TBlockInput.Create(Image));
end;

procedure TFormMain.acActionExecute(Sender: TObject);  //  ""
begin
     FlowChart.Add(TBlockAction.Create(Image));
end;

procedure TFormMain.acIfExecute(Sender: TObject);  //  ""
begin
     FlowChart.Add(TBlockIf.Create(Image));
end;

procedure TFormMain.acCircleExecute(Sender: TObject);  //  ""
begin
     FlowChart.Add(TBlockCircle.Create(Image));
end;

procedure TFormMain.acDelExecute(Sender: TObject);  // 
begin
     FlowChart.DelSelect;
end;

procedure TFormMain.acHLinkExecute(Sender: TObject);  //  
begin
     FlowChart.Add(THorLink.Create(Image));
end;

procedure TFormMain.acVLinkExecute(Sender: TObject);  //  
begin
     FlowChart.Add(TVerLink.Create(Image));
end;


procedure TFormMain.acVersionExecute(Sender: TObject);  // 
begin
     FlowChart.NextMode;
end;

end.
